--[ !!BIG WARNING!!: enjoy suffering on my spaghetty code :) ]--



require('player')
require('level')
require('ennemies')
require('gun')
require('bullet')
require('fullscreen')

wf = require 'libs/windfield'
world = wf.newWorld(0, 0)
love.graphics.setDefaultFilter("nearest", "nearest")

anim8 = require 'libs/anim8'
love.graphics.setDefaultFilter("nearest", "nearest")

sti = require 'libs/sti'
level1 = sti('levels/map1.lua')

camera = require 'libs/camera'
cam = camera()

map1 = love.graphics.newImage("levels/map1.png")
crosshair = love.graphics.newImage("assets/9.png")
bg = love.graphics.newImage("assets/menu.png")

timer = 0
rad = 1270
hotness = 'fill'
hotness2 = 'line'
b_h = 364 * 1.5
b_w = 66 * 2
b_x = (love.graphics.getWidth() / 2) - (b_w * 0.5) - 215
b_y = (love.graphics.getHeight() / 2) - (b_h * 0.5) + 180
b2_y = b_y + b_w * 2

blue = 0
green = 0
red = 0
blue2 = 1
green2 = 1
red2 = 1
font = love.graphics.newFont("fonts/Kenney_Blocks.ttf", 55)
font2 = love.graphics.newFont("fonts/Kenney_Blocks.ttf", 28)

gamestart = false
modedefined = false
isdefiening = false
mode = 'none'

function love.load()
                Diffr = 0.2
            Diffg = 1
            Diffb = 0.2

    fullscreen:load()


    currot = 0

    bullet:load()

    gun:load()

    ennmies:load()

    cam:zoom(2.3)
    level:load()

    player:load()
    math.randomseed(os.time())
end

function love.update(dt)
    fullscreen:update(dt)


    if Fullscreen == true then
        love.window.setFullscreen(true)
    elseif Fullscreen == false then
        love.window.setFullscreen(false)
    end



    if gamestart == false then
        function love.keypressed(key)
            if key == 'down' or key == 'up' then
                if hotness ==  'fill' then
                    red = 1
                    blue = 1
                    green = 1
                    red2 = 0
                    blue2 = 0
                    green2 = 0
                    hotness =  'line'
                    hotness2 = 'fill'
                elseif hotness ==  'line' then
                    red = 0
                    blue = 0
                    green = 0
                    red2 = 1
                    blue2 = 1
                    green2 = 1
                    hotness =  'fill'
                    hotness2 = 'line'
                end
            elseif key == 'return' then
                if hotness ==  'fill' then
                    isdefiening = true
                elseif hotness ==  'line' then
                    love.event.quit(1)
                end
            end
        end
    end

    if isdefiening == true then
        function love.keypressed(key)
            if key == 'e' then
                mode = 'easy'
            elseif key == 'm' then
                mode = 'mid'
            elseif key == 'h' then
                mode = 'hard'
            end
        end
    end




    if mode == 'easy' or mode == 'mid' or mode == 'hard' then
            curx = love.mouse.getX()
            cury = love.mouse.getY()
            currot = currot + 2 * dt
            love.mouse.setVisible(false)
            bullet:update(dt)
            rad = rad - 950 * dt
            timer = timer + 1 *dt
            gun:update(dt)

            ennmies:update(dt)

            level:update(dt)
            cam:lookAt(px, py)
            player:update(dt)
            world:update(dt)
    end
end

function love.draw()
    
    if gamestart == false then
        if Fullscreen == false and mode == 'none'  then
            love.graphics.draw(bg, 0, 0, nil, 6, 6)
            love.graphics.setColor(1,1,1,1)
            love.graphics.rectangle(hotness, b_x + 5, b_y, b_h, b_w)
            love.graphics.rectangle(hotness2, b_x + 5, b2_y, b_h, b_w)
            love.graphics.setColor(red,green,blue,1)
            love.graphics.setFont(font)
            love.graphics.print("Start Game", b_x + 75, b_y + 20)
            love.graphics.setColor(red2,green2,blue2,1)
            love.graphics.setFont(font)
            love.graphics.print("Leave Game", b_x + 75, b2_y + 20)
            love.graphics.setColor(1,1,1,1)
        elseif Fullscreen == true and mode == 'none' then 
            love.graphics.draw(bg, 0, 0, nil, 6, 6)
            love.graphics.setColor(1,1,1,1)
            love.graphics.rectangle(hotness, b_x + 45, b_y, b_h, b_w)
            love.graphics.rectangle(hotness2, b_x + 45, b2_y, b_h, b_w)
            love.graphics.setColor(red,green,blue,1)
            love.graphics.setFont(font)
            love.graphics.print("Start Game", b_x + 115, b_y + 20)
            love.graphics.setColor(red2,green2,blue2,1)
            love.graphics.setFont(font)
            love.graphics.print("Leave Game", b_x + 115, b2_y + 20)
            love.graphics.setColor(1,1,1,1)
        end
        if isdefiening == true and mode == 'none' then
            love.graphics.draw(bg, 0, 0, nil, 6, 6)
            love.graphics.setColor(1,1,1,1)
            love.graphics.rectangle("line", b_x - 73, b_y + 25, b_h + 200, b_w)
            love.graphics.setFont(font)
            love.graphics.print("Choose Difficulty", love.graphics.getWidth() / 2 - 315, love.graphics.getHeight() / 2 - 50)
            love.graphics.setColor(1,1,1,0.8) 
            love.graphics.setFont(font2)
            love.graphics.print("Press e for easy, or m for mid, or h for hard", love.graphics.getWidth() / 2 - 370, love.graphics.getHeight() / 2 + 140)
            love.graphics.setColor(1,1,1,1) 
        end


    
    end
    if mode == 'easy' or mode == 'mid' or mode == 'hard' then
        
        
        cam:attach()

        love.graphics.draw(map1, 0, 0)
        bullet:draw()
        gun:draw()
        ennmies:draw()
        player:draw()
        world:draw()
        cam:detach()
        love.graphics.draw(crosshair, curx, cury, currot, 0.08, 0.08, crosshair:getWidth()/2, crosshair:getHeight()/2)
        love.graphics.setColor(0,0,0,1)
        love.graphics.rectangle("fill", love.graphics.getWidth(), love.graphics.getHeight(), love.graphics.getWidth(), love.graphics.getHeight())
        love.graphics.setColor(1,1,1,1)     
        love.graphics.setFont(font)

        love.graphics.print(enncount, 332, 40, nil, 0.9, 0.9)
        love.graphics.print("Ennemies :", 40, 50, nil, 0.75, 0.75)
        love.graphics.print(math.floor(timer), 176, 110, nil, 0.65, 0.65)
        love.graphics.print("Timer :", 40, 120, nil, 0.5, 0.5)
        love.graphics.setColor(Diffr,Diffg,Diffb,1)
        love.graphics.print(mode, 270, 155, nil, 0.6, 0.6)
        love.graphics.setColor(1,1,1,1)
        love.graphics.print("Difficulty :", 40, 160, nil, 0.5, 0.5)  
        love.graphics.setColor(1,1,1,1) 

        if rad > 0 then
            love.graphics.setColor(0,0,0,1)
            love.graphics.circle("fill", love.graphics.getWidth()/2, love.graphics.getHeight()/2, rad)
            love.graphics.setColor(1,1,1,1)
        end
        if mode == 'easy' then
            Diffr = 0.2
            Diffg = 1
            Diffb = 0.2
        elseif mode == 'hard' then 
            Diffr = 1
            Diffg = 0.2
            Diffb = 0.2
        elseif mode == 'mid' then 
            Diffr = 1
            Diffg = 1
            Diffb = 0.3
        end
    end

end


